local cfg -- config we'll define later
local addon, ns = ... --get addon namespace

local HELM, NECK, SHOULDER, SHIRT, CHEST, WAIST, LEGS, FEET, WRISTS, HANDS, RING1, RING2, TRINK1, TRINK2, BACK, WEP, OFFHAND = 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17;

local ORole = {
	["TANK"]   = {"Interface\\LFGFrame\\LFGRole", 0.5, 0.75, 0, 1},
	["HEALER"] = {"Interface\\LFGFrame\\LFGRole", 0.75, 1, 0, 1},
	["DAMAGER"] = {"Interface\\LFGFrame\\LFGRole", 0.25, 0.5, 0, 1},
	["NONE"] = {"",0,0,0,0}
}
local ORank = {
	[0] = {""},
	[1] = {"Interface\\GROUPFRAME\\UI-GROUP-ASSISTANTICON"},
	[2] = {"Interface\\GROUPFRAME\\UI-Group-LeaderIcon"},
}

local ospec = {
[62] =  "Arcane",
[63] =  "Fire",
[64] =  "Frost",
[65] =  "Holy",
[66] =  "Protection",
[70] =  "Retribution",
[71] =  "Arms",
[72] =  "Fury",
[73] =  "Protection",
[102] =  "Balance",
[103] =  "Feral",
[104] =  "Guardian",
[105] =  "Restoration",
[250] =  "Blood",
[251] =  "Frost",
[252] =  "Unholy",
[253] =  "Beast Mastery",
[254] =  "Marksmanship",
[255] =  "Survival",
[256] =  "Discipline",
[257] =  "Holy",
[258] =  "Shadow",
[259] =  "Assassination",
[260] =  "Combat",
[261] =  "Subtlety",
[262] =  "Elemental",
[263] =  "Enhancement",
[264] =  "Restoration",
[265] =  "Affliction",
[266] =  "Demonology",
[267] =  "Destruction",
[268] =  "Brewmaster",
[269] =  "Windwalker",
[270] =  "Mistweaver",
};

local Oilvlrole = {};
local Oilvlrank = {};
local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local Oilvltimer = LibStub("AceAddon-3.0"):NewAddon("MyAddOn", "AceTimer-3.0")

local OILVL = CreateFrame("Frame");
local oilvlframesw=false;
local oilvlframedata = {};
oilvlframedata.guid = {};
oilvlframedata.name = {};
oilvlframedata.ilvl = {};
oilvlframedata.me = {}; -- miss enchant
oilvlframedata.spec = {}; -- specialization;

local OILVL_Unit="";
local OTilvl=0;
local OTmia=0;
local OTTop=0;	
local Omover=0;
local OTCurrent=""; -- current raid frame
local OTCurrent2=""; -- current unit id
local OTCurrent3=""; -- current raid frame number
local ountrack=true;
local ail=0; -- average item level
local miacount=0;
local miaunit={};

-- OT Check Raid Item Level
function oilvl(unit)
	if not UnitAffectingCombat("player") then
		OILVL_Unit=unit;
		if CheckInteractDistance(OILVL_Unit, 1) and CanInspect(OILVL_Unit) then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect(OILVL_Unit);
			local htex4 = _G[OTCurrent]:CreateTexture()
			htex4:SetTexture(0,1,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			_G[OTCurrent]:SetNormalTexture(htex4)
		else
			OILVL_Unit="";
			miacount=0;
			miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
			local ntex4 = _G[OTCurrent]:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			_G[OTCurrent]:SetNormalTexture(ntex4)
			OTCurrent = "";
			OTCurrent2 = "";
			OTCurrent3 = "";
			ountrack=true;			
		end
	end
end
	
-- Get Raid Frame Item Level
function ORfbIlvl(ounit)
if not UnitAffectingCombat("player") and ounit ~= "" then
	local i=0;
	OTCurrent3 = tonumber(ounit);
	if IsInRaid() then
		OTCurrent = "OILVLRAIDFRAME"..ounit;		
		OTCurrent2 = "raid"..ounit;
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
			oilvl(OTCurrent2);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		if ounit == "1" or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(tonumber(ounit)-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		if ounit == "1"  or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(tonumber(ounit)-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvlframedata.name[tonumber(ounit)] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
				oilvl(OTCurrent2);
			end
		end
	else
		OTCurrent = "OILVLRAIDFRAME1";
		OTCurrent2 = "player";
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvlframedata.name[1] = GetUnitName(OTCurrent2,""):gsub("%-.+", "");
			oilvl(OTCurrent2);
		end
	end
end
end

function OilvlSetRole(ounit, orole)
	Oilvlrole[ounit]:SetTexture(ORole[orole][1]);
	Oilvlrole[ounit]:SetTexCoord(ORole[orole][2],ORole[orole][3],ORole[orole][4],ORole[orole][5]);
end

function OilvlSetRank(ounit, orole)
	Oilvlrank[ounit]:SetTexture(ORank[orole][1]);
end

function OilvlSetMouseoverTooltips(oframe, ounit)
	oframe:SetAttribute("unit", ounit);
	oframe:SetScript("OnEnter", function(self)
		OilvlTooltip:SetOwner(oframe, "ANCHOR_BOTTOMRIGHT");
		OilvlTooltip:SetUnit(ounit)
		OilvlTooltip:SetUnit(ounit)
		local i = tonumber(self:GetName():gsub("OILVLRAIDFRAME", "").."");
		if oilvlframedata.me[i] ~= "" then
			if oilvlframedata.spec[i] ~= "" then
				OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
				OilvlTooltip:AddLine("Spec: |cFF00FF00"..oilvlframedata.spec[i]);
			end
			OilvlTooltip:SetHeight(GameTooltip:GetHeight()+15);
			OilvlTooltip:AddLine("Please enchant:\n|cFF00FF00"..oilvlframedata.me[i]);
		end
		OilvlTooltip:Show()
	end) 
end

function oilvlcheckunknown()
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("raid"..i,""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("raid"..i);
				oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.spec[i] = "";
			end
		end
	else
		return 0
	end
end

function OILVLCheckUpdate()
if not UnitAffectingCombat("player") and OILVL_Unit == "" and oilvlframesw then
	oilvlcheckunknown();
	ountrack=false;
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i] then break; end
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00",""):gsub("\n|r|cFF00FF00",":"):gsub("\n|r|cFFFF0000",":");
		local ochar, ilvl = strsplit(":",msg,2)	
		if ilvl == nil or ilvl == "" then
			ountrack = true;
			if IsInRaid() then
				if CheckInteractDistance("raid"..i, 1) and CanInspect("raid"..i) then ORfbIlvl(i); return 0; end
			elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			else
				ORfbIlvl(1); return 0;
			end
		end
	end	
end
end
	
function OVILRefresh()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local rnum=0;
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	for i = 1, 40 do
		-- reset the color of all frames
		if not _G["OILVLRAIDFRAME"..i]  then break; end
		local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
		ntex4:SetTexture(0.2,0.2,0.2,0.5)
		ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex4:SetAllPoints()	
		_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)			
		
		-- reset data
		oilvlframedata.guid[i] = "";
		oilvlframedata.name[i] = "";
		oilvlframedata.ilvl[i] = "";
		oilvlframedata.me[i] = "";
		oilvlframedata.spec[i] = "";
	end
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(266);
		end
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end
		for i = rnum+1, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		for i = 1, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("raid"..i,""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = UnitGUID("raid"..i);
			oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = rnum, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(266);
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = rnum, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(266);
	else
		for i = 2, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(266);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
end
-- Same as OVILRefresh(), but do not clear item level.
function OilvlCheckFrame()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local j=0;
	local rnum=0;
	local td = {};
	td.guid = {};
	td.name = {};
	td.ilvl = {};
	td.me = {};
	td.spec = {};
	for i=1,40 do
		td.guid[i] = "";
		td.name[i] = "";
		td.ilvl[i] = "";
		td.me[i] = "";
		td.spec[i] = "";
	end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(266);
		end		
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end

		for j=1, rnum do
			for i=1, 40 do
				if oilvlframedata.guid[i] == "" then break end
				if UnitGUID("raid"..j) == oilvlframedata.guid[i] then
					td.guid[j] = oilvlframedata.guid[i];
					td.name[j] = oilvlframedata.name[i];
					td.ilvl[j] = oilvlframedata.ilvl[i];
					td.me[j] = oilvlframedata.me[i];
					td.spec[j] = oilvlframedata.spec[i];
					break;
				end
			end
			if td.guid[j] == "" then
				td.guid[j] = UnitGUID("raid"..j);
				td.name[j] = GetUnitName("raid"..j,""):gsub("%-.+", "");
				td.ilvl[j] = "";
				td.me[j] = "";
				td.spec[j] = "";
			end
		end

		for i = rnum+1, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		for i = 1, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = td.guid[i];
			oilvlframedata.name[i] = td.name[i];
			oilvlframedata.ilvl[i] = td.ilvl[i];
			oilvlframedata.me[i] = td.me[i];
			oilvlframedata.spec[i] = td.spec[i];
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1		
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						td.me[j+1] = oilvlframedata.me[i];
						td.spec[j+1] = oilvlframedata.spec[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
					td.me[j+1] = "";
					td.spec[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.spec[i] = "";
			end
			OILVLRAIDFRAME1:Show();
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				oilvlframedata.me[i] = td.me[i];
				oilvlframedata.spec[i] = td.spec[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(266);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						td.me[j+1] = oilvlframedata.me[i];
						td.spec[j+1] = oilvlframedata.spec[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
					td.me[j+1] = "";
					td.spec[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
				oilvlframedata.me[i] = "";
				oilvlframedata.spec[i] = "";
			end
			OILVLRAIDFRAME1:Show();
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				oilvlframedata.me[i] = td.me[i];
				oilvlframedata.spec[i] = td.spec[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(266);
		end
	else
		OIVLFRAME:SetWidth(266);
		for i = 2, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
			oilvlframedata.me[i] = "";
			oilvlframedata.spec[i] = "";
		end
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(266);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		oilvlframedata.me[1] = "";
		oilvlframedata.spec[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3="";
end

local function round(number, digits)
    return tonumber(string.format("%." .. (digits or 0) .. "f", number))
end

function oilvlcheckrange()
if not UnitAffectingCombat("player") and oilvlframesw then
	local i=0;
	local rnum=0;
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if not CheckInteractDistance("raid"..i, 1) then
				if OTCurrent2 == "raid"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)
			else
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)					
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				if OTCurrent2 == "party"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then		
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				if OTCurrent2 == "party"..i then
					miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
					ountrack=true; OTCurrent=""; OTCurrent2=""; OTCurrent3=""; OILVL_Unit="";
				end
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end
		end
	end
	if OTCurrent ~= "" then
		local htex4 = _G[OTCurrent]:CreateTexture()
		htex4:SetTexture(0,1,1,0.5)
		htex4:SetTexCoord(0, 0.625, 0, 0.6875)
		htex4:SetAllPoints()
		_G[OTCurrent]:SetNormalTexture(htex4)	
	end
	if ountrack and not UnitAffectingCombat("player") then
		Oilvltimer:ScheduleTimer(OILVLCheckUpdate,1);
	end
	if OILVL_Unit ~= "" then ORfbIlvl(OTCurrent3); end
-- Calculate Average Item Level
	local total=0;
	local n=0;
	for i = 1, 40 do 
		if oilvlframedata.ilvl[i] ~= "" then 
			n = n + 1;
			total = total + oilvlframedata.ilvl[i];
		end
	end
	if(n ~= 0) then ail = round(total/n,1); end
	if ail then
		OilvlAIL:SetText("Average Item Level: "..ail);
	else
		OilvlAIL:SetText("Average Item Level: 0");
		ail = 0;
	end
end
end

function OSendToTarget()
	local i=0;
	if not UnitExists("target") then 
		return -1;
	end
	SendChatMessage("Item Level:", "WHISPER", nil, UnitName("target"));
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "WHISPER", nil, UnitName("target"));
	end
	SendChatMessage("Average Item Level: "..ail, "WHISPER", nil, UnitName("target"));
end

function OSendToParty()
	local i=0;
	SendChatMessage("Item Level:", "PARTY");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "PARTY");
	end
	SendChatMessage("Average Item Level: "..ail, "PARTY");
end

function OSendToInstance()
	local i=0;
	SendChatMessage("Item Level:", "INSTANCE_CHAT");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "INSTANCE_CHAT");
	end
	SendChatMessage("Average Item Level: "..ail, "INSTANCE_CHAT");
end

function OSendToGuild()
	local i=0;
	SendChatMessage("Item Level:", "GUILD");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "GUILD");
	end
	SendChatMessage("Average Item Level: "..ail, "GUILD");
end

function OSendToRaid()
	local i=0;
	SendChatMessage("Item Level:", "RAID");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "RAID");
	end
	SendChatMessage("Average Item Level: "..ail, "RAID");
end

function OSendToOfficer()
	local i=0;
	SendChatMessage("Item Level:", "OFFICER");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		if cfg.oilvlme and oilvlframedata.me[i] ~= "" then
			msg = msg.." (Pls enchant "..oilvlframedata.me[i]..")";
		end
		SendChatMessage(msg, "OFFICER");
	end
	SendChatMessage("Average Item Level: "..ail, "OFFICER");
end

function oilvlbutton(btnName, btnText, btnParent, btnTemplate, btnPoint, btnX, btnY, btnW, btnH, btnFunc)
	local button = CreateFrame("Button", btnName, btnParent, btnTemplate)
	button:SetPoint(btnPoint, btnX, btnY)
	button:SetWidth(btnW)
	button:SetHeight(btnH)
	
	button:SetText(btnText)
	button:SetNormalFontObject("GameFontNormal")
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)
	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)

	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", btnFunc);
end

function oilvlcfgbutton(btnParent)
	local button = CreateFrame("Button", "oilvlcfgbutton", btnParent)
--	button:SetPoint("TOPLEFT", 39, 20)
	button:SetPoint("TOPLEFT", -10, 10)
	button:SetWidth(70)
	button:SetHeight(70)
	
--    local border = button:CreateTexture(nil, "BORDER");
--    border:SetSize(64,64);
--    border:SetPoint("CENTER", 12, -13);
--    border:SetTexture("Interface/Minimap/MiniMap-TrackingBorder");

	local ntex = button:CreateTexture(nil, "BACKGROUND")
--	ntex:SetSize(52,52);
	ntex:SetSize(120,120);
	ntex:SetPoint("CENTER",-1,1);
	ntex:SetTexture("Interface/AddOns/Oilvl/config.tga")
	
	local htex = button:CreateTexture()
--	htex:SetSize(40,40);
	htex:SetSize(70,70);
	htex:SetPoint("CENTER",-1,1);
	htex:SetTexture("Interface/Minimap/UI-Minimap-ZoomButton-Highlight")
	button:SetHighlightTexture(htex)
	
	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", function(self, button) 
		PlaySound("igMainMenuOption");
		InterfaceOptionsFrameTab2:Click();
		InterfaceOptionsFrame_OpenToCategory("O Item Level (OiLvL)")
	end);
end
	
function oilvlframe()
	local f = CreateFrame("Frame", "OIVLFRAME", UIParent, "ButtonFrameTemplate");
	f:SetWidth(676);
	f:SetHeight(330);
	f:SetFrameStrata("LOW");

-- set moveable and dragable	
	f:SetMovable(true);
	f:EnableMouse(true);
	f:RegisterForDrag("LeftButton");
	f:SetScript("OnDragStart", f.StartMoving);
	f:SetScript("OnDragStop", function() f:StopMovingOrSizing();  cfg.oilvlframeP, _, _, cfg.oilvlframeX, cfg.oilvlframeY = f:GetPoint() end);

-- Set Title
	f.text = f.text or f:CreateFontString(nil,"ARTWORK", "GameTooltipText");
	f.text:SetAllPoints(true);
	f.text:SetPoint("TOPLEFT",0,-6);
	f.text:SetJustifyH("CENTER");
	f.text:SetJustifyV("TOP");
	f.text:SetTextColor(1,1,1,1);
	f.text:SetText("O Item Level");	

--background texture
	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(0.1,0.1,0.1,0.5)
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("TOPLEFT",15,-60);
	
 --icon
--    local icon = f:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
--    icon:SetSize(60,60);
--    icon:SetPoint("TOPLEFT",-5,7);
--    icon:SetTexture("Interface/AddOns/Oilvl/config.tga");
--    icon:SetTexCoord(0,1,0,1);
--    f.icon = icon;

-- Average Item Level
	local ail = f:CreateFontString("OilvlAIL","ARTWORK","GameFontHighlight")
	ail:SetPoint("BOTTOMLEFT",10,30)
	ail:SetText("Average Item Level:");

-- 	Enchantment Reminder
	local ercb = CreateFrame("CheckButton", "oilvlercb", f, "ChatConfigCheckButtonTemplate");
	ercb:SetPoint("BOTTOMRIGHT", -20,25);
	getglobal(ercb:GetName() .. 'Text'):SetText("ER");
	ercb.tooltip = "Enable Sending Enchantment Reminder";
	ercb:SetHitRectInsets(0,0,0,0);
	ercb:SetSize(25,25);
	ercb:SetScript("PostClick", function() cfg.oilvlme = oilvlercb:GetChecked(); oicb4:SetChecked(cfg.oilvlme) end);
	ercb:SetChecked(cfg.oilvlme);
	
-- Config Button
	oilvlcfgbutton(f);
--Refresh button
	oilvlbutton("OILVLREFRESH", "Refresh", f, "OptionsButtonTemplate", "TOPRIGHT", -6, -35, 60, 22, function(self, button) OVILRefresh() end);
--Party button
	oilvlbutton("OILVLParty", "Party", f, "OptionsButtonTemplate", "TOPRIGHT", -68, -35, 60, 22, function(self, button) OSendToParty() end);
--Target button
	oilvlbutton("OILVLTarget", "Target", f, "OptionsButtonTemplate", "TOPRIGHT", -130, -35, 60, 22, function(self, button) OSendToTarget() end);
--Instance button
	oilvlbutton("OILVLINSTANCE", "Instance", f, "OptionsButtonTemplate", "BOTTOMLEFT", 3, 3, 80, 22, function(self, button) OSendToInstance() end);
-- Guild button
	oilvlbutton("OILVLGUILD", "Guild", f, "OptionsButtonTemplate", "BOTTOMLEFT", 85, 3, 50, 22, function(self, button) OSendToGuild() end);
-- Raid button
	oilvlbutton("OILVLRAID", "Raid", f, "OptionsButtonTemplate", "BOTTOMLEFT", 137, 3, 50, 22, function(self, button) OSendToRaid()	end);
-- Officer button
	oilvlbutton("OILVLOfficer", "Officer", f, "OptionsButtonTemplate", "BOTTOMLEFT", 190, 3, 60, 22, function(self, button) OSendToOfficer()	end);
-- Party / Raid Frame
	local rfb=1; -- raid frame button
	local b4i=0;
	local b4j=0;
	for b4j = 1, 8 do
		for b4i = 1, 5 do
			local button4 = CreateFrame("Button", "OILVLRAIDFRAME"..rfb, f, "SecureActionButtonTemplate")
			button4:SetPoint("TOPLEFT", 10+(b4j-1)*82, -66-(b4i-1)*42)
			button4:SetWidth(80)
			button4:SetHeight(40)	
			button4:SetText("")
			button4:SetNormalFontObject("GameFontNormal")			
	
			local ntex4 = button4:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			button4:SetNormalTexture(ntex4)
	
			local htex4 = button4:CreateTexture()
			htex4:SetTexture(0,0,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			button4:SetHighlightTexture(htex4)
	
			local ptex4 = button4:CreateTexture()
			ptex4:SetTexture(0,1,1,0.5)
			ptex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ptex4:SetAllPoints()
			button4:SetPushedTexture(ptex4)
		
			-- Left Click
			button4:RegisterForClicks("LeftButtonDown", "RightButtonDown");
			button4:SetScript("PostClick", function(self, button, down) 					
					if button == "LeftButton" or button == "LeftButtonDown" then
						ORfbIlvl(self:GetName():gsub("OILVLRAIDFRAME", "").."") 
					end
			end);
			
			-- Right Click
			button4:SetAttribute("type2", "target");
			button4:SetAttribute("target2", "mouseover");
			
			-- hide tooltips
			button4:SetScript("OnLeave", function(self) OilvlTooltip:Hide() end)

			-- set role variable
			Oilvlrole[rfb] = button4:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
			Oilvlrole[rfb]:SetSize(15,15);
			Oilvlrole[rfb]:SetPoint("BOTTOMRIGHT",0,0);
			Oilvlrole[rfb]:SetTexture(nil);
			Oilvlrole[rfb]:SetTexCoord(0,0,0,0);
			-- set rank variable
			Oilvlrank[rfb] = button4:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
			Oilvlrank[rfb]:SetSize(15,15);
			Oilvlrank[rfb]:SetPoint("TOPLEFT",0,5);
			Oilvlrank[rfb]:SetTexture(nil);
--			Oilvlrank[rfb]:SetTexCoord(0,0,0,0);
			
			rfb = rfb + 1;
		end
	end	
	
-- Oilvl Game Tooltips
	CreateFrame("GameTooltip", "OilvlTooltip", nil, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
	-- Allow tooltip SetX() methods to dynamically add new lines based on these
	OilvlTooltip:AddFontStrings(
		OilvlTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
		OilvlTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) );

-- Refresh
	oilvlframesw=true;
	OVILRefresh();
	f:SetScale(0.8);
	f:Hide();
--	tinsert(UISpecialFrames,"OIVLFRAME");
--	f:SetUserPlaced(true);
end
-- OCategory is the expansion title.
-- ORaidname is the raid title.
-- Oprint is to print out the result if true.
-- Example:
-- OilvlGetStatisticId("Warlords of Draenor", "Highmaul", OSTATHM, false)
-- OilvlGetStatisticId("Warlords of Draenor", "Blackrock Foundry", OSTATBF, false)
function OilvlGetStatisticId(OCategory, ORaidName, OTable, Oprint)
	local str = ""
	for _, CategoryId in pairs(GetStatisticsCategoryList()) do
		local Title, ParentCategoryId, Something
		Title, ParentCategoryId, Something = GetCategoryInfo(CategoryId)
		
		if Title == OCategory then
			local i
			local statisticCount = GetCategoryNumAchievements(CategoryId)
			local j=1; -- boss Count
			local k=1; -- difficulties Count
			for i = 1, statisticCount do
				local IDNumber, OOName, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(CategoryId, i)
				if OOName:find(ORaidName) then
					if k == 1 then
						OTable[j] = {}
					end
					OTable[j][k] = IDNumber;
					if k < 4 then
						k = k + 1;
					else
						k = 1;
						j = j + 1;
					end
					if Oprint then
						print(OOName..":"..IDNumber)
					end
				end
			end
		end
	end
end

local OSTATHM = {}
OilvlGetStatisticId("Warlords of Draenor", "Highmaul", OSTATHM, false)
local OSTATBF = {}
OilvlGetStatisticId("Warlords of Draenor", "Blackrock Foundry", OSTATBF, false)

function OGetRaidProgression(RaidName, OSTAT, NumRaidBosses)
	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find(RaidName.." Progression");
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine(RaidName.." Progression:");
	end
	local op=0;
	for i = 1, NumRaidBosses do	
		if GetComparisonStatistic(OSTAT[i][4]) ~= "--" then
			op = op + 1;
		end
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFFMythic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][3]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFFHeroic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFFNormal ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, NumRaidBosses do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/"..NumRaidBosses.." |r|cFFFFFFFFLFR ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00none";
	end
	if not omatch then
		if progression ~= "" then
			GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
			GameTooltip:AddLine(progression);
		end
	else
		_G["GameTooltipTextLeft"..matchi]:SetText(progression);
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	ClearAchievementComparisonUnit();
end

local oenchantItem = {
	[0] = {0, "ammo"},
	[1] = {0, "head"},
	[2] = {1, "neck"},
	[3] = {0, "shoulder"},
	[4] = {0, "shirt"},
	[5] = {0, "chest"},
	[6] = {0, "waist"},
	[7] = {0, "legs"},
	[8] = {0, "boot"},
	[9] = {0, "bracer"},
	[10] = {0, "glove"},
	[11] = {1, "ring 1"},
	[12] = {1, "ring 2"},
	[13] = {0, "trinket 1"},
	[14] = {0, "trinket 2"},
	[15] = {1, "cloak"},
	[16] = {1, "weapon"},
	[17] = {1, "off hand weapon"},
}

function OTgathertil(guid, unitid)
	local totalIlvl, avgIlvl = 0
	local iter_min, iter_max = 0
	local itemLevel = 0
	local equipType = 0
	local twoHander = nil
	local mia = 0;
	local count = 0
	local missenchant = "";
	for i = 1,17 do
		if(i ~= SHIRT) then
			local item = GetInventoryItemLink(unitid, i)
			if(item) then
				local upgradeID = ItemUpgradeInfo:GetUpgradeID(item)
				local upgrade = ItemUpgradeInfo:GetCurrentUpgrade(upgradeID)
				_,_,_,itemLevel,_,itemClass,_,_,equipType = GetItemInfo(item)
				
				-- check miss enchant
				local _,enchant,_,_,_,_,_ = item:match("item:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)");
				if oenchantItem[i][1] == 1 and enchant == "0" then
					if missenchant == "" then
						missenchant = missenchant..oenchantItem[i][2]; 
					else
						if i ~= 17 or itemClass ~= "Armor" then
							missenchant = missenchant..", "..oenchantItem[i][2]; 
						end
					end
				end

				if(itemLevel) then
					count = count + 1
					if(i == WEP) then
						if(equipType == "INVTYPE_2HWEAPON" or equipType == "INVTYPE_RANGED" or equipType == "INVTYPE_RANGEDRIGHT") then
							twoHander = 1
						end
					end

					if(upgrade == 1) then 
						itemLevel = itemLevel + 4
					elseif(upgrade == 2) then
						itemLevel = itemLevel + 8
					elseif(upgrade == 3) then
						itemLevel = itemLevel + 12
					elseif(upgrade == 4) then
						itemLevel = itemLevel + 16
					end
					totalIlvl = totalIlvl + itemLevel
				end
			end
		end
	end
	
	if count < 15 and twoHander then
		mia = 15-count;	
	end
	if count < 16 and not twoHander then
		mia = 16-count;
	end
	
	if((count == 15) and twoHander) then
		avgIlvl = round(totalIlvl / count,1)
	elseif((count == 16) and not twoHander) then
		avgIlvl = round(totalIlvl / count, 1)
	elseif((count == 16) and twoHander) then
		avgIlvl = round(totalIlvl / 16, 1)
	elseif((count == 15) and not twoHander) then
		avgIlvl = round(totalIlvl / 16, 1)
	else
		avgIlvl = round(totalIlvl / 15, 1)
	end
return avgIlvl, mia, missenchant;
end

function OTInspect(self,event,unit,role)
	if UnitAffectingCombat("player") == false and event ~= "PLAYER_LEAVING_WORLD" then
		if event == "INSPECT_READY" then
			if OILVL_Unit ~= "" then				
				if CheckInteractDistance(OILVL_Unit, 1) then
					OTilvl, OTmia, missenchant = OTgathertil(UnitGUID("OILVL_Unit"),OILVL_Unit)
					if (OTmia == 0) then
						miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
						if missenchant ~= "" then
							oilvlframedata.name[OTCurrent3] = oilvlframedata.name[OTCurrent3]:gsub("!","");
							oilvlframedata.name[OTCurrent3] = "! "..oilvlframedata.name[OTCurrent3]
							oilvlframedata.me[OTCurrent3] = missenchant;							
						else
							oilvlframedata.name[OTCurrent3] = oilvlframedata.name[OTCurrent3]:gsub("!","");
							oilvlframedata.me[OTCurrent3] = "";
							oilvlframedata.spec[OTCurrent3] = "";
						end
						if oilvlframedata.name[OTCurrent3] ~= "" then
							_G[OTCurrent]:SetText("|cFFFFFF00"..oilvlframedata.name[OTCurrent3].."\n|r|cFF00FF00"..OTilvl);
							oilvlframedata.ilvl[OTCurrent3] = OTilvl;
							local temp = ospec[GetInspectSpecialization(OILVL_Unit)];
							if temp ~= nil then oilvlframedata.spec[OTCurrent3] = temp;	else oilvlframedata.spec[OTCurrent3] = ""; end
						end
						OTCurrent = "";
						OTCurrent2 = "";
						OTCurrent3 = "";
						ountrack=true;
						OILVL_Unit="";						
					else
						if OTmia < 3 then
							miacount = miacount + 1
							miaunit[miacount] = UnitGUID("OILVL_Unit");
							if miaunit[1] == miaunit[2] and miaunit[2] == miaunit[3] and miaunit[3] == miaunit[4] and miaunit[4] == miaunit[5] and miaunit[5] == miaunit[6] then
								miacount=0;	miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
								OILVL_Unit="";
								local ntex4 = _G[OTCurrent]:CreateTexture()
								ntex4:SetTexture(0.2,0.2,0.2,0.5)
								ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
								ntex4:SetAllPoints()	
								_G[OTCurrent]:SetNormalTexture(ntex4)
								if oilvlframedata.name[OTCurrent3] ~= "" then
									_G[OTCurrent]:SetText("|cFFFFFF00"..oilvlframedata.name[OTCurrent3].."\n|r|cFFFF0000"..OTilvl);
									oilvlframedata.ilvl[OTCurrent3] = OTilvl;
								end
								OTCurrent = "";
								OTCurrent2 = "";
								OTCurrent3 = "";
								ountrack=true;						
							end
						end
					end
				else
					OILVL_Unit="";
					if OTCurrent ~= "" then
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
					end
					OTCurrent = "";
					OTCurrent2 = "";
					OTCurrent3 = "";
					ountrack=true;
				end	
			end
			-- GameTooltip		
			if (Omover ==1) and cfg.oilvlms then
				Omover=0;
				if not UnitAffectingCombat("player") and cfg.oilvlms and UnitExists("target") and CheckInteractDistance("target", 1) then
					local oname, _ = GameTooltip:GetUnit();
					if oname ~= nil then oname = oname:gsub("%-.+", ""); else return -1; end
					if oname ~= GetUnitName("target",""):gsub("%-.+", "") then return -1; end
					local OTilvl2, OTmia2, missenchant = OTgathertil(UnitGUID("target"),"target")
					if (OTmia2 == 0) then
						local i=0;
						local omatch=false;
						local oospec = ospec[GetInspectSpecialization("target")];
						-- spec
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Spec:");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Spec: |r|cFF00FF00"..oospec);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Spec: |r|cFF00FF00"..oospec);	
						end
						-- item level
						omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Item Level: |r|cFF00FF00"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Item Level: |r|cFF00FF00"..OTilvl2);	
						end
					else
						local i=0;
						local omatch=false;
						local oospec = ospec[GetInspectSpecialization("target")];
						-- spec
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Spec:");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Spec: |r|cFF00FF00"..oospec);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Spec: |r|cFF00FF00"..oospec);	
						end
						-- item level
						omatch=false;						
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end						
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Item Level: |r|cFFFF0000"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Item Level: |r|cFFFF0000"..OTilvl2);	
						end
						Oilvltimer:ScheduleTimer(OMouseover,1);
					end
				end
			end
			OILVL:UnregisterEvent("INSPECT_READY")
			ClearInspectPlayer()
		end
		
		if event == "INSPECT_ACHIEVEMENT_READY" then
			if cfg.oilvlhm then OGetRaidProgression("Highmaul", OSTATHM, 7); end
			if cfg.oilvlbf then OGetRaidProgression("BF", OSTATBF, 10); end
		end
		
		if event == "GROUP_ROSTER_UPDATE" then
			--OVILRefresh();
			if oilvlframesw then OilvlCheckFrame(); end
		end
		
		if event == "RAID_ROSTER_UPDATE" then
			--OVILRefresh();
			if oilvlframesw then OilvlCheckFrame(); end
		end
		
		if event == "PLAYER_EQUIPMENT_CHANGED" then
			if oilvlframesw then ORfbIlvl(1); end
		end
	end
	
	if event == "VARIABLES_LOADED" then
		cfg = Oilvl_Settings;
		if cfg.oilvlframeP == nil then cfg.oilvlframeP = "TOPLEFT"; end
		if cfg.oilvlframeX == nil then cfg.oilvlframeX = 15; end
		if cfg.oilvlframeY == nil then cfg.oilvlframeY = -60; end
		if cfg.oilvlscale  == nil then cfg.oilvlscale = 0.8; end
		if cfg.oilvlalpha  == nil then cfg.oilvlalpha = 1; end
		if cfg.oilvlhm == nil then cfg.oilvlhm = true; end
		if cfg.oilvlbf == nil then cfg.oilvlbf = true; end
		if cfg.oilvlms == nil then cfg.oilvlms = true; end
		if cfg.oilvlme == nil then cfg.oilvlme = true; end
		if cfg.oilvlcharilvl == nil then cfg.oilvlcharilvl = true; end
	end
		
	if event == "PLAYER_LOGIN" then
		OilvlConfigFrame();
		oilvlframe();
		Oilvltimer:ScheduleTimer(OVILRefresh,2);
		Oilvltimer:ScheduleRepeatingTimer(oilvlcheckrange,1);
		GameTooltip:HookScript("OnTooltipSetUnit", function() 
			if not UnitAffectingCombat("player") and cfg.oilvlms and UnitExists("target") then
				local oname, _ = GameTooltip:GetUnit()
				if oname ~= nil then oname = oname:gsub("%-.+", ""); else return -1; end
				if  oname == GetUnitName("target",""):gsub("%-.+", "") then
					OMouseover();
				end
			end 
		end); 
		print("O Item Level (|cFFFFFF00OiLvL|r|cFFFFFFFF) |r|cFF00FF00v"..GetAddOnMetadata("Oilvl","Version").." |r|cFFFFFFFF is loaded.")
		print("|cFF00FF00/oi|r|cFFFFFFFF to display |r|cFFFFFF00OiLvL|r|cFFFFFFFF's frame.");
		print("|cFF00FF00/oicfg|r|cFFFFFFFF to display |r|cFFFFFF00OiLvL|r|cFFFFFFFF's configuration frame.");
		ShowUIPanel(InterfaceOptionsFrame);
		InterfaceOptionsFrame.lastFrame = GameMenuFrame;
		InterfaceOptionsFrameTab2:Click();
		InterfaceOptionsFrameCancel:Click();
		HideUIPanel(GameMenuFrame);
	end
		
	if event == "PLAYER_ENTERING_WORLD" then
		--OVILRefresh();
		if oilvlframesw then Oilvltimer:ScheduleTimer(OilvlCheckFrame,10); end
	end
		
	if event == "PLAYER_REGEN_DISABLED" then
		if oilvlframesw then
			local nn=1;
			for nn=1, 40 do
				_G["OILVLRAIDFRAME"..nn]:Disable();
			end
			OILVLREFRESH:Hide();
		end
	end
	
	if event == "PLAYER_REGEN_ENABLED" then
		if oilvlframesw then
			local nn=1;
			for nn=1, 40 do
				if not _G["OILVLRAIDFRAME"..nn]  then break; end
				_G["OILVLRAIDFRAME"..nn]:Disable();
				_G["OILVLRAIDFRAME"..nn]:Enable();
			end
			OILVLREFRESH:Show();
			OilvlCheckFrame();
		end
	end	
	
	if event == "ROLE_CHANGED_INFORM" then
		if oilvlframesw then
			if IsInRaid() then
				local rnum = GetNumGroupMembers();
				local i = 1;
				for i = 1, rnum do
					if GetUnitName("raid"..i,true) == self then
						OilvlSetRole(i, role);
					end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
				local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
				if GetUnitName("player",true) == self then
					OilvlSetRole(1, role);
				end
				local i = 2;
				for i = 2, rnum do
					if GetUnitName("party"..(i-1),true) == self then
						OilvlSetRole(i, role);
					end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
				if GetUnitName("player",true) == self then
					OilvlSetRole(1, role);
				end
				local i = 2;
				for i = 2, rnum do
					if GetUnitName("party"..(i-1),true) == self then
						OilvlSetRole(i, role);
					end
				end
			end	
		end
	end
	
	if event =="LFG_ROLE_UPDATE" or event == "PLAYER_SPECIALIZATION_CHANGED" then
		if oilvlframesw then OILVLCheckUpdate(); end
	end
end
	-- Set GameTooltip	
function OMouseover()
	if not UnitAffectingCombat("player") and cfg.oilvlms and oilvlframesw then
		if CheckInteractDistance("target", 1) and CanInspect("target") then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect("target");
			Omover=1;
			ClearAchievementComparisonUnit();
			SetAchievementComparisonUnit("target");
			OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		end
	end
end

function OilvlConfigFrame()
	cfg.frame = CreateFrame("Frame",addon.."Config",InterfaceOptionsFramePanelContainer)
	cfg.frame.name = "O Item Level (OiLvL)"
	InterfaceOptions_AddCategory(cfg.frame)

	local title = cfg.frame:CreateFontString(nil,"ARTWORK","GameFontNormalLarge")
	title:SetPoint("TOPLEFT",16,-16)
	title:SetText("O Item Level (OiLvL) v"..GetAddOnMetadata("Oilvl","Version")) -- can get version from GetAddOnMetadata
	
--  oilvl scale
	local oscale = CreateFrame("Slider", "Oilvlscale", cfg.frame, "OptionsSliderTemplate")
	oscale:SetWidth(200)
	oscale:SetHeight(20)
	oscale:SetOrientation('HORIZONTAL');
	oscale:SetPoint("TOPLEFT",16,-70);
	
	local scaletitle = oscale:CreateFontString(nil,"ARTWORK","GameFontNormal")
	scaletitle:SetPoint("LEFT",oscale,"LEFT",0,35)
	scaletitle:SetText("O Item Level Frame");

	getglobal(oscale:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
	getglobal(oscale:GetName() .. 'High'):SetText('100'); --Sets the right-side slider text (default is "High").
	getglobal(oscale:GetName() .. 'Text'):SetText('Scale'); --Sets the "title" text (top-centre of slider).
	
	oscale:SetMinMaxValues(0, 1);
	oscale:SetValue(cfg.oilvlscale);
	oscale:RegisterForDrag("LeftButton");
	oscale:SetScript("OnDragStop", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	oscale:SetScript("OnMouseDown", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	
--  oilvl transparent
	local oalpha = CreateFrame("Slider", "Oilvlalpha", cfg.frame, "OptionsSliderTemplate")
	oalpha:SetWidth(200)
	oalpha:SetHeight(20)
	oalpha:SetOrientation('HORIZONTAL');
	oalpha:SetPoint("TOPLEFT",16,-120);
	
	getglobal(oalpha:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(oalpha:GetName() .. 'High'):SetText('1'); --Sets the right-side slider text (default is "High").
	getglobal(oalpha:GetName() .. 'Text'):SetText('Transparency'); --Sets the "title" text (top-centre of slider).
	
	oalpha:SetMinMaxValues(0, 1);
	oalpha:SetValue(cfg.oilvlalpha);
	oalpha:RegisterForDrag("LeftButton");	
	oalpha:SetScript("OnMouseDown", function(self, button) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
	oalpha:SetScript("OnDragStop", function(self) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
	
	-- Raid Progression Checkbutton
	local uniquealyzer = 0;
	function createCheckbutton(parent, x_loc, y_loc, displayname)
		uniquealyzer = uniquealyzer + 1;
	
		local checkbutton = CreateFrame("CheckButton", "oicb"..uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
		checkbutton:SetPoint("TOPLEFT", parent, "TOPLEFT", x_loc, y_loc);
		getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
		checkbutton:SetHitRectInsets(0,0,0,0);
		return checkbutton;
	end

	-- Tooltips option
	local mscb = createCheckbutton(cfg.frame, 16, -170, " Enable Showing item level / raid progression on tooltips");
	mscb:SetSize(30,30);
	mscb:SetScript("PostClick", function() cfg.oilvlms = oicb3:GetChecked() end);
	if cfg.oilvlms then mscb:SetChecked(true) end
	
	-- Highmaul check button
	local hmcb = createCheckbutton(cfg.frame, 16, -200, " Highmaul");
	hmcb:SetSize(30,30);
	hmcb:SetScript("PostClick", function() cfg.oilvlhm = oicb1:GetChecked() end);
	if cfg.oilvlhm then hmcb:SetChecked(true) end

	-- Blackrock Foundry check button
	local bfcb = createCheckbutton(cfg.frame, 120, -200, " Blackrock Foundry");
	bfcb:SetSize(30,30);
	bfcb:SetScript("PostClick", function() cfg.oilvlbf = oicb2:GetChecked() end);	
	if cfg.oilvlbf then bfcb:SetChecked(true) end
	
	
	-- miss enchant option
	local eercb = createCheckbutton(cfg.frame, 16, -230, " Enable Sending Enchantment Reminder");
	eercb:SetSize(30,30);
	eercb:SetScript("PostClick", function() cfg.oilvlme = oicb4:GetChecked() oilvlercb:SetChecked(cfg.oilvlme) end);
	eercb:SetChecked(cfg.oilvlme);

	-- character frame item level option
	local cfilvlcb = createCheckbutton(cfg.frame, 16, -260, " Enable Showing Item Level on Character Frame");
	cfilvlcb:SetSize(30,30);
	cfilvlcb:SetScript("PostClick", function() cfg.oilvlcharilvl = oicb5:GetChecked() OiLvlPlayer_Update() end);
	if cfg.oilvlcharilvl then cfilvlcb:SetChecked(true) end	
end

--[[Fix for Lua errors with Blizzard_AchievementUI below]]--
local unregistered,reregistered
local function reregisterBlizz()
	if not reregistered then
		AchievementFrameComparison:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		reregistered=true
	end
end
local function unregisterBlizz(name)
	if not unregistered then
		if not name or name=="Blizzard_AchievementUI" then
			AchievementFrameComparison:UnregisterEvent("INSPECT_ACHIEVEMENT_READY")
			hooksecurefunc("InspectAchievements",reregisterBlizz)
			unregistered=true
		end
	end
end
if IsAddOnLoaded("Blizzard_AchievementUI") then
	unregisterBlizz()
else
	hooksecurefunc("LoadAddOn",unregisterBlizz)
end
------------------------------------------------------------------

SLASH_OILVL_OILVL1 = "/oilvl"

SlashCmdList["OILVL_OILVL"] = function()
	OIVLFRAME:ClearAllPoints();
	OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
	OIVLFRAME:SetScale(cfg.oilvlscale);
	OIVLFRAME:SetAlpha(cfg.oilvlalpha);
	OIVLFRAME:Show();
end

SLASH_OILVL_OI1 = "/oi"

SlashCmdList["OILVL_OI"] = function()
	OIVLFRAME:ClearAllPoints();
	OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
	OIVLFRAME:SetScale(cfg.oilvlscale);
	OIVLFRAME:SetAlpha(cfg.oilvlalpha);
	OIVLFRAME:Show();
end

SLASH_OILVL_OICFG1 = "/oicfg"

SlashCmdList["OILVL_OICFG"] = function()
	InterfaceOptionsFrameTab2:Click();
	InterfaceOptionsFrame_OpenToCategory("O Item Level (OiLvL)")
end
	
OILVL:SetScript("OnEvent", OTInspect)
OILVL:RegisterEvent("PLAYER_LEAVING_WORLD");
OILVL:RegisterEvent("GROUP_ROSTER_UPDATE");
OILVL:RegisterEvent("RAID_ROSTER_UPDATE");
OILVL:RegisterEvent("VARIABLES_LOADED");
OILVL:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
OILVL:RegisterEvent("PLAYER_LOGIN");
OILVL:RegisterEvent("PLAYER_ENTERING_WORLD");
OILVL:RegisterEvent("PLAYER_REGEN_DISABLED");
OILVL:RegisterEvent("PLAYER_REGEN_ENABLED");
OILVL:RegisterEvent("ROLE_CHANGED_INFORM");
OILVL:RegisterEvent("LFG_ROLE_UPDATE");
OILVL:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");